# ****************************************************************************
# Surgeweb javascript - Core "webmail" logic / server io code
# Note: sw.js is the primary surgeweb javascript code
# ----------------------------------------------------------------------------
#  - implementation of ajax server interfacing commands
#  - error handling
#  - message caching
# ****************************************************************************


# Actually execute the send command through a constructed post request
var sending_now = ""
var boundaryString, boundary;

function ajax_send(jmsg,move,cb)
{
	||DEBUGGER||
	jmsg.move=move;
	jmsg.cmd='cmd=send,show&page=~result.js&msg_id='+jmsg.cache_mid+'&fld_id='+jmsg.fld+'&send_type='+jmsg.action+'&if=ajax'+jmsg.params;

	dbg('send params [M'+jmsg.instance+']'+jmsg.cmd);
	if (!jmsg.from_popup&&!jmsg.report){
		jmsg.sending_now=sw.active;
		window_manager_minimise(sw.active,true);
	}
	set_status("Sending...","info");

#	dbg('sending - queue adding request')
	queued_req_add( enQ, function(jmsg){	
#		dbg('sending - actioning request')
		sndReqPost2(jmsg.cmd, jmsg.msg_html, function(chan){
#			dbg('sending - request completed')
			var success=actionReqJsStat(chan);
	||DEBUGGER||
#			Authentication error handling still needs further tidying somehow...		
			if(!success || global_auth_error){
				message_send_error(jmsg);
			}else{
				message_send_success(jmsg);
			}
		},ch[enQ]);
	}, jmsg);
}
function ajax_save_draft(jmsg,move,cb)
{
	var spellcheck=false;
	jmsg.move=move;
	jmsg.cmd='cmd=save_draft,show&page=~result.js&msg_id='+jmsg.cache_mid+'&fld_id='+jmsg.fld+'&if=ajax'+jmsg.params;
	
	if (sw.run_spellcheck_once){
		spellcheck=true;
		jmsg.cmd=jmsg.cmd+'&run_spellcheck=true';
		sw.run_spellcheck_once=false;
	}
	
#	dbg('save_draft - queue adding request')
	queued_req_add( enQ, function(jmsg,cb){	
#		dbg('save_draft - actioning request')
		sndReqPost2(jmsg.cmd, jmsg.msg_html, function(chan){
#			dbg('save_draft - request completed')
			var success=actionReqJsStat(chan);
			if(!success || global_auth_error){
				if(spellcheck)
					set_status(success_string,"warning");
				else
					set_status("Save draft failed","warning");
			}else{
				jmsg.edit_uid=g_edit_uid;
				if (cb) cb(jmsg);
			}
		},ch[enQ]);
	}, jmsg,cb);
}
var g_edit_uid;
function edit_uid(uid)
{
	g_edit_uid=uid;
}

function ajax_delete(msgs)
{
	for_each_msg(msgs,'pending');
	var dst="Trash";
	dbg('delete - queue adding request')
	queued_req_add( enQ, function(msgs){
		dbg('delete - actioning request')
		sndReq('cmd=delete,show&page=~result.js&'+sel_all_params(msgs)+'&fld_id='+msgs.fid, function(chan){
			dbg('delete - request completed')
			var success=actionReqJsStat(chan);
			if (!success){
				for_each_msg(msgs,'nopending');
				set_status(messages_text(msgs)+' could not be deleted : '+success_string,'warning');
			}else{
				for_each_msg(msgs,function(row){row.parentNode.removeChild(row);sw.nav_count--;sw.nav_total--;});
				set_status(messages_text(msgs)+' moved to <a href="#" onclick="F(\''+dst+'\')">'+dst+'</a>',"success");
				if(msgs.sel_all) {sw.nav_count=sw.nav_total=0;}
				navigator_update();
			}
		},ch[enQ]);
	}, msgs);
}
function ajax_purge(fld)
{
	dbg('purge - queue adding request')
	queued_req_add( enQ, function(fld){
		dbg('purge - actioning request')
		sndReq('cmd=delete,show&page=~result.js&sel=&sel_all=true&fld_id='+fld, function(chan){
			dbg('purge - request completed')
			var success=actionReqJsStat(chan);
			if (!success){
				set_status('Purge failed','warning');
			}else{
				set_status(fld+' purged','success');
			}
		},ch[enQ]);
	}, fld);
}

function ajax_set_flags(msgs,action,flags,fn)
{
	dbg('set_flags - queue adding request');
	queued_req_add( enQ, function(msgs,action,flags,fn){
		dbg('set_flags - actioning request')
		sndReq('cmd=set_flags,show&page=~result.js&'+sel_all_params(msgs)+"&fld_id="+msgs.fid+"&flags_action="+action+"&flags="+flags, function(chan){
			dbg('set_flags - request completed')
			var success=actionReqJsStat(chan);
			if (!success){
				set_status(messages_text(msgs)+' flags could not be updated : '+success_string,'warning');
			}else{
				for_each_msg(msgs,fn);
			}
		},ch[enQ]);
	},msgs,action,flags,fn);
}

function ajax_msg_move(msgs,dst)
{
# 	clone the array
	for_each_msg(msgs,'pending');
	dbg('msg_move - queue adding request ['+msgs+']');
	queued_req_add( enQ, function(msgs,dst){
		dbg('msg_move - actioning request');
		sndReq('cmd=msg_move,show&page=~result.js&'+sel_all_params(msgs)+"&destination="+dst+"&fld_id="+msgs.fid, function(chan){
			dbg('msg_move - request completed');
			var success=actionReqJsStat(chan);
			var ok=check_for_ok(success,success_string);
			if (!(success||ok)){
				for_each_msg(msgs,'nopending');
				set_status(messages_text(msgs)+' could not be moved : '+success_string,'warning');
			}else{
				for_each_msg(msgs,function(row){row.parentNode.removeChild(row);sw.nav_count--;sw.nav_total--;});
				if(ok)
					set_status(messages_text(msgs)+' '+success_string,"success");
				else
					set_status(messages_text(msgs)+' moved to <a href="#" onclick="F(\''+escape(dst)+'\')">'+dst+'</a>',"success");
				
				if(msgs.sel_all) {sw.nav_count=sw.nav_total=0;}
				navigator_update();
			}
		}, ch[enQ]);	
	},msgs,dst);
}

function ajax_msg_copy(msgs,dst)
{
	dbg('msg_copy - queue adding request ['+msgs+']');
	queued_req_add( enQ, function(msgs,dst){
		dbg('msg_copy - actioning request');
		sndReq('cmd=msg_copy,show&page=~result.js&'+sel_all_params(msgs)+"&destination="+dst+"&fld_id="+msgs.fid, function(chan){
			dbg('msg_copy - request completed');
			var success=actionReqJsStat(chan);
			var ok=check_for_ok(success,success_string);
			if (!(success||ok)){
				set_status(messages_text(msgs)+' could not be copied : '+success_string,'warning');
			}else{
				if(ok)
					set_status(messages_text(msgs)+' '+success_string,"success");
				else
					set_status(messages_text(msgs)+' copied to <a href="#" onclick="F(\''+dst+'\')">'+dst+'</a>',"success");			
			}
		}, ch[enQ]);	
	},msgs,dst);
}



# Background preferences save - this should not generate warnings if it fails generally
function ajax_pref_save(txt)
{
	var data;
	data='cmd=save_options,show&page=~result.js';
	data+='&'+txt;
	queued_req_add( enQ, function(data){
		sndReqPost(data, function(chan){
			var success=actionReqJsStat(chan);			
			// Do success fail check
		},ch[enQ]);		
	},data);
}

# Cache messages
function ajax_cache_messages(msgs, nostatus)
{
	var showstatus=(nostatus==undefined)?true:false;
	dbg('cache_messages - queue adding request ['+msgs+']');
	queued_req_add( enBG, function(msgs,showstatus){	    
		dbg('cache_messages - actioning request');
		if (showstatus) set_status('Caching '+msgs.length+' '+msgs.fid+' messages ...','info');
		sndReq('cmd=show&page=~cache_msgs.js&fld_id='+msgs.fid+'&msgids='+msgs.join(','), function(chan){
			dbg('cache_messages - request completed');
			doneloading();
			dbg("cached messages received");
			actionReqAllmsgsJS(chan.responseText);			
			if (showstatus) set_status('Caching '+msgs.fid+' complete','success');
		},ch[enBG]);		
	},msgs,showstatus);
}

# Get the attachments from an existing message (forwarding / forward_attach / edit draft)
function ajax_attach_get(jmsg,cb)
{
	dbg('attach_get - queue adding request ');
	queued_req_add( enQ, function(jmsg,cb){	    
		dbg('attach_get - actioning request');
		sndReq('cmd=attach_get,show&page=~result.js&msg_id='+jmsg.cache_mid+'&fld_id='+jmsg.fld+'&attach_mid='+jmsg.attach_mid+'&send_type='+jmsg.action+(jmsg.sel_mids.length>0?'&sel='+jmsg.sel_mids.join(','):''), function(chan){
			dbg('attach_get - request completed');
			var success=actionReqJsStat(chan);						
			cb(g_new_attach);			
		},ch[enQ]);		
	},jmsg,cb);
}

var spam_rating_updates={};
function ajax_spam_rating(msgs,action,fn)
{
	var do_update=((action=='notspam'||action=='once') && msgs.fid!='Spam');
	for_each_msg(msgs,'pending');

	dbg('spam_rating - queue adding request');
	queued_req_add( enQ, function(msgs,action,do_update,fn){
		dbg('spam_rating - actioning request')
		sndReq('cmd=spam_rating,show&page=~result.js&'+sel_all_params(msgs)+"&fld_id="+msgs.fid+"&spam_action="+action, function(chan){
			dbg('spam_rating - request completed')
			var success=actionReqJsStat(chan);
			success=check_for_ok(success,success_string);
			if (!success){
#				if(!do_update)
				for_each_msg(msgs,'nopending');
				set_status(messages_text(msgs)+' spam rating could not be updated : '+success_string,'warning');
			}else{
				for_each_msg(msgs,function(row,mid){
					var update=spam_rating_updates[mid];
					if(do_update && update){						
						row_to_sel(row).id='sel_'+update['new_mid'];
						row_to_subject(row).innerHTML=update['subject'];
						class_remove(row,'action_pending');
						show_preview(update['new_mid'],undefined,undefined,undefined,true);
#						preview_msg(update['new_mid'],undefined,true);
					}else{
						row.parentNode.removeChild(row);sw.nav_count--;sw.nav_total--;
					}
				});
				set_status(messages_text(msgs)+' '+success_string,'success');
				for_each_msg(msgs,fn);
#				if(update) F(msgs.fid,msgs.fld_type,0,true);
			}
		},ch[enQ]);
	},msgs,action,do_update,fn);
}


function check_for_ok(success,txt)
{
	if(!success && txt.substring(0,4)=='+OK:'){
		success_string=txt.substring(4);
		return true;
	}
	return false;
}

# ***** Handling & mitigation of various errors *****

function comms_error()
{
	alert("communcation error, try again?");
}
function try_relogin(error)
{
	var txt='<div>Session no longer valid, login again?</div><div>Note: You will be able to continue where you left off.</div>'		
	if(error)txt+='<div style="color:red;margin-top:10px;margin-left:60px;">'+error+'</div>';
	x_custom_dlg(txt,
			'<span id="login_result"></span>' +
			'Username: '+username+'@'+domain+' <input type="hidden" id="username_ex" value="'+username+'"><br>' +
			'Password:<input type="password" id="password" value="">', try_relogin_action, function(){setTimeout(function(){dge('password').focus();},1)});
}
||define||dat_file||~x_login_sw.js||
function try_relogin_action(btn)
{
	if (btn==0)	return;
	sndReq("cmd=login,show&username_ex="+username+"&domain_ex="+domain+"&password="+dge("password").value+"&page=||dat_file||",function(chan){
		eval(chan.responseText);		
		var new_sid = response['sid'];
		var result = response['result'];
		var ver = response['version'];
		if (new_sid==0){
			try_relogin(result);		
			dbg("LOGIN",'login failed');		
			return;
		}
		sid=new_sid;
		dbg("LOGIN",'login successful new sid='+sid);
		set_status('Session successfully logged in again','success');
		x_dlg_hide();
		
		if(!check_version(ver)) return;
		
		if(global_request_reissue){
			sndReq(global_request_reissue, function(chan){
				doneloading();
				success = actionReqJs(chan);
			});
			global_request_reissue=null;
		}
		
	});

	return false;
}

var global_auth_error=false;
var global_request_reissue;

function auth_error()
{
	global_auth_error=true;;
	try_relogin();
	return;

	// Old relogin window
	x_confirm("Session no longer valid, login again? <br> note: you will be able to continue where you left off",function(n){
		if (!n)return;
		sw_login = new LoginSurgeweb();
		dge("dlg_ovrl").style.display='';
		sw_login.init(mylogin_cb,"DOM",/*"modal"*/"dlg_ovrl","drag","focus");
		sw_login.showDialog();
	});
}

function cookie_error()
{
	x_alert('No <span style="color:red;font-weight:bold;">valid cookies were supplied by browser</span>, so surgeweb can not work. Make sure coookies are enabled in your browser.<br><br>'+
			'Note: Some browsers do not supply cookies on urls that are ip numbers: eg. <b>http://127.0.0.1/surgeweb</b> (in particular Google Chrome and Konqueror) '+
			'If you are using one of these browsers try a name based url: eg. <b>http://mydomain.com/surgeweb</b> or an alternative browser.',function(){document.location.href="||cgi||?cmd=logout"});
}


# Allow relogin
var sw_login;
function mylogin_cb(success,sid,result){
    if(!success) return;
    dge("dlg_ovrl").style.display='none';
    
	sw_login.destroy();
	delete sw_login;
	if(sid==0){
		dbg('cancel pressed');
		return;
	}
	mysid = sid;
	dbg("We are logged in, tidied up and have a SID="+sid);
}

function message_send_error(jmsg)
{
	set_status(success_string,"warning");
	if (send_timer)	clearTimeout(send_timer);
	if (global_auth_error){
#		// Already have a relogin dialog
		message_send_error_step2(jmsg);	
#		Already have message window displayed again
		global_auth_error=false;
	}else{
#		debugger;
		var extra;
		if(success_string.indexOf("No such user")!=-1){
			if(jmsg.to.length+jmsg.cc.length+jmsg.bcc.length>1)
				extra='<br><br>None of the recipients have received their email';
			else
				extra='<br><br>Your message has not been sent';
		}else{
			extra='';
		}
		x_alert('<div style="margin-left:70px">'+success_string+extra+'</div>',function(){ message_send_error_step2(jmsg)});
	}
}
function message_send_error_step2(jmsg)
{
	if (jmsg.from_popup){
		//need to reset anything??	(used to convert msg types)
		jmsg.not_new=true;

		show_edit(jmsg);
	}else{
		if (sw.active!=sending_now) {
			window_manager_minimise(sw.active);
			restoreMsgFromTab(jmsg.sending_now.tab_ref);	
		}
	}
}


function message_send_success(jmsg)
{
	if (pref.sounds=='sent' || pref.sounds=='all') 
		play_sound('sent');
		
#	setTimeout(function(){
		var dest='Sent';
		set_status('Sent OK and copied to <a href="#" onclick="F(\''+dest+'\')"> '+dest+'</a> folder','success');
		
		for_each_msg(jmsg.sel_mids,function(row){
			class_add(row,'msg_replied');

#			// IE does not immediately render changes to classes sometimes (go IE) so force it to below (Yuck)
			if (/*isIE*/true){	// just make every browser do it for now
				var xx=row.nextSibling
				if (xx){
					row.parentNode.removeChild(row)
					xx.parentNode.insertBefore(row,xx)
				}
			}
		});

	||DEBUGGER||
		if(jmsg.sending_now){
			window_manager_killpane(jmsg.sending_now);
		}
		if(jmsg.move){
			var sel=jmsg.sel_mids;
			sel.fid=jmsg.fld;
			ajax_msg_move(sel,"Done");
		}	
#	},150);
}

# ***** Responses & message caching *****

function setMessages(txt)
{
	var el=document.getElementById('messages_list');
	var h=el.offsetHeight;
	el.innerHTML=txt;
	var msgs=find_msgs();
	dbg("h b4="+h+' h now='+el.offsetHeight+' changing to='+list_h);
#	el.style.height=px(list_h);
	
	var fld=sw.fid;

	if(isIE) do_resize_real();

	if (sw.done_prefetch) return;
	
	prefetch_init(msgs);
	return;
	if (pref['nocache'] || msgs.length==0) return;

	if (!done_cache && fld=='INBOX') setTimeout(function(){		
  		done_cache=true;
#	  	setTimeout(function(){	// Run it through a timer so FF updates it's screen with status info!!?? 
		ajax_cache_messages(msgs);	
#	  	},10);
	},3000);
}

# Implement the message caching
var sw_cache=new Object();
var sw_xcache=new Array();
var done_cache=false;
function actionReqAllmsgsJS(txt)
{
	eval(txt);
	var tmp=allmsgs;	
	for (var i=0;i<tmp.length;i++){
		var g=tmp[i];		
		cache_add(sw.fid+'_'+g.mid, g);
	}
	allmsgs=null;
}



function cache_add(cache_id,txt)
{
	if (sw_xcache.length>500)
		cache_remove(sw_xcache.shift());
	sw_cache[cache_id]=txt;
	sw_xcache.push(cache_id);
}

function cache_remove(cache_id,search)
{
	sw_cache[cache_id]=null;
	if(search){
		var i=my_indexOf(sw_xcache,cache_id);
		if(i!=-1)
			sw_xcache.splice(i,1);  
	}
}

function cache_clear()
{
	sw_cache=new Object();
	sw_xcache=new Array();
	done_cache=false;
}

function html_from_cache(idx)
{
	var qmsg=sw_cache[idx];
	return html_from_qmsg(qmsg);
}
function html_from_qmsg(qmsg)
{
	if(qmsg==null)debugger
	return qmsg.html.replace(/%%the_msg%%/,qmsg.msg_html);
}

function sel_all_params(sel)
{
	var txt='sel='+sel;
	if(sel.sel_all) txt+='&sel_all='+sel.sel_all;
	return txt;
}
